#include <bits/stdc++.h>
using namespace std;

vector < pair < long long , int > > vp;
vector < long long > ans;


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, q; cin >> n >> q;

    for(int i = 0; i < n; i++) 
    {
        long long d; int p;
        cin >> d >> p;
        vp.push_back({d, p});
    }

    long long a = 0;
    int pos = 0;
    long long kraj = 0;

    for(int i = 0; i < q; i++)
    {
        long long k; cin >> k;

        while(pos < n)
        {
            // cout << k << ": " << pos << "pre: " << kraj << "\n";
            long long trpoc = vp[pos].first;
            long long trkraj = vp[pos].first + vp[pos].second - 1;

            if(kraj >= k) break;
            if(trpoc > k) break;

            if(trpoc > kraj + 1)
            {
                a += trpoc - kraj - 1;
            }
            else
            {
                trkraj += kraj - trpoc + 1;
            }
            kraj = trkraj;
            pos++;
        }

        if(k > kraj)
        {
            ans.push_back(k - (a + k - kraj));
        }
        else
        {
            ans.push_back(k - a);
        }
    }

    for(auto it : ans) cout << it << "\n";

    return 0;
}